{
  open Lexing Parser;

  exception LexicalError of string * int * int (* (message, loc1, loc2) *)

 fun lexerError lexbuf s =
     raise LexicalError (s, getLexemeStart lexbuf, getLexemeEnd lexbuf)
}
rule token = parse
  [` ` `\t` `\n` `\r`]	{ token lexbuf }
| "class" { CLASS }
| "if" { IF }
| "then" { THEN }
| "else" { ELSE }
| "end" { END }
| "def" { DEF }
| "nil" { NIL }
| "self" { SELF }
| "begin" { BEGIN }
| "new" { NEW }
| `:` { COL }
| `<` { INHERITS }
| `(` { LP }
| `)` { RP }
| `,` { COMMA }
| `;` { SEMI }
| `.` { DOT }
| `=` { EQ }
| `"` [^`"`]* `"` { let val s = getLexeme lexbuf in STR(String.substring(s, 1, ((String.size s) - 2))) end }
| [`0`-`9`]+ { INT(Option.valOf (Int.fromString (getLexeme lexbuf))) }
| [`A`-`Z``a`-`z``+``-``*``/``_``!``?`]+ { ID(getLexeme lexbuf) }
| `@`[`A`-`Z``a`-`z``+``-``*``/``_``!``?`]+ { FID(getLexeme lexbuf) }
| eof { EOF }
| _ { lexerError lexbuf "Illegal symbol in input" }
;
